#include <TinyScreen.h>
#include "SoundStream.hpp"
#include "TwinkleBeep01.h"

TinyScreen tiny_screen = TinyScreen(TinyScreenPlus);
int wave_sample;

void setup()
{
	tiny_screen.begin();
	tiny_screen.setBitDepth(TSBitDepth8);
	tiny_screen.setBrightness(8);
	tiny_screen.setFont(liberationSansNarrow_12ptFontInfo);
	tiny_screen.fontColor(TS_8b_White, TS_8b_Black);
	InitializeSoundStream();
	wave_sample = 0;
}

void loop()
{
	tiny_screen.setCursor(0,0);
	tiny_screen.print("Now playing!");
	UpdateSoundStream();
	int writable_size = GetSoundStreamWritableSize();
	int wave_size = static_cast<int>(sizeof(TwinkleBeep01_wave));
	if(writable_size > 0)
	{
		size_t write_size = writable_size;
		size_t left_size = wave_size - wave_sample;
		if(left_size < writable_size)
		{
			write_size = left_size;
		}
		if(write_size > 0)
		{
			unsigned char* write_wave_buffer = new unsigned char[writable_size];
			memcpy(write_wave_buffer, &TwinkleBeep01_wave[wave_sample], write_size);
			wave_sample += write_size;
			if(writable_size > left_size)
			{
				int left_write_size = writable_size - left_size;
				if(left_write_size > 0)
				{
					wave_sample = 0;
					memcpy(&write_wave_buffer[write_size], &TwinkleBeep01_wave[wave_sample], left_write_size);
					wave_sample += left_write_size;
				}
			}
			WriteSoundStream(write_wave_buffer);
			delete [] write_wave_buffer;
		}
		if(wave_sample >= wave_size)
		{
			wave_sample = 0;
		}
	}
}
